#[doc = "Register `SWD_CONFIG` reader"]
pub struct R(crate::R<SWD_CONFIG_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<SWD_CONFIG_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<SWD_CONFIG_SPEC>> for R {
    fn from(reader: crate::R<SWD_CONFIG_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `SWD_CONFIG` writer"]
pub struct W(crate::W<SWD_CONFIG_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<SWD_CONFIG_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<SWD_CONFIG_SPEC>> for W {
    fn from(writer: crate::W<SWD_CONFIG_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `SWD_SELECT` reader - 0: Use Primary SWD location?1: Use Alternate SWD location"]
pub struct SWD_SELECT_R(crate::FieldReader<bool, bool>);
impl SWD_SELECT_R {
    pub(crate) fn new(bits: bool) -> Self {
        SWD_SELECT_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for SWD_SELECT_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `SWD_SELECT` writer - 0: Use Primary SWD location?1: Use Alternate SWD location"]
pub struct SWD_SELECT_W<'a> {
    w: &'a mut W,
}
impl<'a> SWD_SELECT_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | (value as u8 & 0x01);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - 0: Use Primary SWD location?1: Use Alternate SWD location"]
    #[inline(always)]
    pub fn swd_select(&self) -> SWD_SELECT_R {
        SWD_SELECT_R::new((self.bits & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - 0: Use Primary SWD location?1: Use Alternate SWD location"]
    #[inline(always)]
    pub fn swd_select(&mut self) -> SWD_SELECT_W {
        SWD_SELECT_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "SWD pinout selector (not present in TSG4/TSG5-M)\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [swd_config](index.html) module"]
pub struct SWD_CONFIG_SPEC;
impl crate::RegisterSpec for SWD_CONFIG_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [swd_config::R](R) reader structure"]
impl crate::Readable for SWD_CONFIG_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [swd_config::W](W) writer structure"]
impl crate::Writable for SWD_CONFIG_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets SWD_CONFIG to value 0"]
impl crate::Resettable for SWD_CONFIG_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
